//
//  TCPconnections.swift
//  RsyncOSX
//
//  Created by Thomas Evensen on 24.08.2018.
//  Copyright © 2018 Thomas Evensen. All rights reserved.
//

import Foundation

// Protocol for doing a refresh in main view after testing for connectivity
protocol Connections: AnyObject {
    func displayConnections()
}

final class TCPconnections {
    var client: TCPClient?

    // Test for TCP connection
    func verifyTCPconnection(_ host: String, port: Int, timeout: Int) -> Bool {
        self.client = TCPClient(address: host, port: Int32(port))
        guard let client = client else { return true }
        switch client.connect(timeout: timeout) {
        case .success:
            return true
        default:
            return false
        }
    }
}
